Index: /trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompiler.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompiler.cpp	(revision 106191)
+++ /trunk/src/VBox/VMM/VMMAll/IEMAllN8veRecompiler.cpp	(revision 106192)
@@ -2789,4 +2789,22 @@
 
 # endif /* defined(IEMNATIVE_WITH_DELAYED_REGISTER_WRITEBACK) || defined(IEMNATIVE_WITH_SIMD_REG_ALLOCATOR) */
+
+# ifdef IEMNATIVE_WITH_EFLAGS_POSTPONING
+/**
+ * Debug Info: Record info about emitting a postponed EFLAGS calculation.
+ */
+DECL_HIDDEN_THROW(void)
+iemNativeDbgInfoAddPostponedEFlagsCalc(PIEMRECOMPILERSTATE pReNative, uint32_t off, IEMNATIVE_POSTPONED_EFL_OP_T enmOp,
+                                       uint8_t cOpBits, uint8_t idxEmit)
+{
+    iemNativeDbgInfoAddNativeOffset(pReNative, off);
+    PIEMTBDBGENTRY const pEntry = iemNativeDbgInfoAddNewEntry(pReNative, pReNative->pDbgInfo);
+    pEntry->PostponedEflCalc.uType      = kIemTbDbgEntryType_PostponedEFlagsCalc;
+    pEntry->PostponedEflCalc.enmOp      = (unsigned)enmOp;
+    pEntry->PostponedEflCalc.cOpBits    = cOpBits;
+    pEntry->PostponedEflCalc.idxEmit    = idxEmit;
+    pEntry->PostponedEflCalc.uUnused    = 0;
+}
+# endif /* IEMNATIVE_WITH_EFLAGS_POSTPONING */
 
 #endif /* IEMNATIVE_WITH_TB_DEBUG_INFO */
@@ -9172,5 +9190,5 @@
                 for (; iDbgEntry < cDbgEntries; iDbgEntry++)
                 {
-                    switch (pDbgInfo->aEntries[iDbgEntry].Gen.uType)
+                    switch ((IEMTBDBGENTRYTYPE)pDbgInfo->aEntries[iDbgEntry].Gen.uType)
                     {
                         case kIemTbDbgEntryType_GuestInstruction:
@@ -9351,7 +9369,25 @@
 # endif
 
+# ifdef IEMNATIVE_WITH_EFLAGS_POSTPONING
+                        case kIemTbDbgEntryType_PostponedEFlagsCalc:
+                        {
+                            const char *pszOp = "!unknown!";
+                            switch ((IEMNATIVE_POSTPONED_EFL_OP_T)pDbgInfo->aEntries[iDbgEntry].PostponedEflCalc.enmOp)
+                            {
+                                case kIemNativePostponedEflOp_Logical: pszOp = "logical"; break;
+                                case kIemNativePostponedEflOp_Invalid: break;
+                                case kIemNativePostponedEflOp_End:     break;
+                            }
+                            pHlp->pfnPrintf(pHlp, "  Postponed EFLAGS calc #%u: %s %u bits\n",
+                                            pDbgInfo->aEntries[iDbgEntry].PostponedEflCalc.idxEmit, pszOp,
+                                            pDbgInfo->aEntries[iDbgEntry].PostponedEflCalc.cOpBits);
+                            continue;
+                        }
+# endif
                         default:
                             AssertFailed();
+                            continue;
                     }
+                    /* Break out of the loop at kIemTbDbgEntryType_NativeOffset. */
                     iDbgEntry++;
                     break;
Index: /trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veEmit-x86.h
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veEmit-x86.h	(revision 106191)
+++ /trunk/src/VBox/VMM/VMMAll/target-x86/IEMAllN8veEmit-x86.h	(revision 106192)
@@ -255,4 +255,8 @@
         pReNative->PostponedEfl.idxReg1 = UINT8_MAX;
         pReNative->PostponedEfl.idxReg2 = UINT8_MAX;
+#if defined(VBOX_WITH_STATISTICS) || defined(IEMNATIVE_WITH_TB_DEBUG_INFO)
+        STAM_PROFILE_ADD_PERIOD(&pReNative->pVCpu->iem.s.StatNativeEflPostponedEmits, pReNative->PostponedEfl.cEmits);
+        pReNative->PostponedEfl.cEmits = 0;
+#endif
     }
 }
@@ -362,4 +366,9 @@
                                                    uint32_t bmExtraTlbMissRegs = 0)
 {
+#ifdef IEMNATIVE_WITH_TB_DEBUG_INFO
+    iemNativeDbgInfoAddPostponedEFlagsCalc(pReNative, off, pReNative->PostponedEfl.enmOp, pReNative->PostponedEfl.cOpBits,
+                                           pReNative->PostponedEfl.cEmits);
+#endif
+
     /*
      * In the TB exit code path we cannot do regular register allocation.  Nor
@@ -459,4 +468,7 @@
     IEMNATIVE_ASSERT_INSTR_BUF_ENSURE(pReNative, off);
 
+#if defined(VBOX_WITH_STATISTICS) || defined(IEMNATIVE_WITH_TB_DEBUG_INFO)
+    pReNative->PostponedEfl.cEmits++;
+#endif
     return off;
 }
Index: /trunk/src/VBox/VMM/VMMR3/IEMR3.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR3/IEMR3.cpp	(revision 106191)
+++ /trunk/src/VBox/VMM/VMMR3/IEMR3.cpp	(revision 106192)
@@ -755,4 +755,7 @@
         REG_NATIVE_EFL_GROUP(shift,      Shift);
 #   undef REG_NATIVE_EFL_GROUP
+
+        STAMR3RegisterF(pVM, &pVCpu->iem.s.StatNativeEflPostponedEmits, STAMTYPE_PROFILE, STAMVISIBILITY_ALWAYS, STAMUNIT_NONE,
+                        "Postponed EFLAGS calculation emits", "/IEM/CPU%u/re/NativeEFlags/ZZEmits", idCpu);
 
         STAMR3RegisterF(pVM, &pVCpu->iem.s.StatNativeLivenessEflCfSkippable,    STAMTYPE_COUNTER, STAMVISIBILITY_ALWAYS, STAMUNIT_COUNT, "Skippable EFLAGS.CF updating",       "/IEM/CPU%u/re/NativeLivenessEFlags/CfSkippable", idCpu);
Index: /trunk/src/VBox/VMM/include/IEMInternal.h
===================================================================
--- /trunk/src/VBox/VMM/include/IEMInternal.h	(revision 106191)
+++ /trunk/src/VBox/VMM/include/IEMInternal.h	(revision 106192)
@@ -1329,189 +1329,4 @@
 
 /**
- * Translation block debug info entry type.
- */
-typedef enum IEMTBDBGENTRYTYPE
-{
-    kIemTbDbgEntryType_Invalid = 0,
-    /** The entry is for marking a native code position.
-     * Entries following this all apply to this position. */
-    kIemTbDbgEntryType_NativeOffset,
-    /** The entry is for a new guest instruction. */
-    kIemTbDbgEntryType_GuestInstruction,
-    /** Marks the start of a threaded call. */
-    kIemTbDbgEntryType_ThreadedCall,
-    /** Marks the location of a label. */
-    kIemTbDbgEntryType_Label,
-    /** Info about a host register shadowing a guest register. */
-    kIemTbDbgEntryType_GuestRegShadowing,
-#ifdef IEMNATIVE_WITH_SIMD_REG_ALLOCATOR
-    /** Info about a host SIMD register shadowing a guest SIMD register. */
-    kIemTbDbgEntryType_GuestSimdRegShadowing,
-#endif
-#ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING
-    /** Info about a delayed RIP update. */
-    kIemTbDbgEntryType_DelayedPcUpdate,
-#endif
-#if defined(IEMNATIVE_WITH_DELAYED_REGISTER_WRITEBACK) || defined(IEMNATIVE_WITH_SIMD_REG_ALLOCATOR)
-    /** Info about a shadowed guest register becoming dirty. */
-    kIemTbDbgEntryType_GuestRegDirty,
-    /** Info about register writeback/flush oepration. */
-    kIemTbDbgEntryType_GuestRegWriteback,
-#endif
-    kIemTbDbgEntryType_End
-} IEMTBDBGENTRYTYPE;
-
-/**
- * Translation block debug info entry.
- */
-typedef union IEMTBDBGENTRY
-{
-    /** Plain 32-bit view. */
-    uint32_t u;
-
-    /** Generic view for getting at the type field. */
-    struct
-    {
-        /** IEMTBDBGENTRYTYPE */
-        uint32_t    uType : 4;
-        uint32_t    uTypeSpecific : 28;
-    } Gen;
-
-    struct
-    {
-        /** kIemTbDbgEntryType_ThreadedCall1. */
-        uint32_t    uType      : 4;
-        /** Native code offset. */
-        uint32_t    offNative  : 28;
-    } NativeOffset;
-
-    struct
-    {
-        /** kIemTbDbgEntryType_GuestInstruction. */
-        uint32_t    uType      : 4;
-        uint32_t    uUnused    : 4;
-        /** The IEM_F_XXX flags. */
-        uint32_t    fExec      : 24;
-    } GuestInstruction;
-
-    struct
-    {
-        /* kIemTbDbgEntryType_ThreadedCall. */
-        uint32_t    uType       : 4;
-        /** Set if the call was recompiled to native code, clear if just calling
-         *  threaded function. */
-        uint32_t    fRecompiled : 1;
-        uint32_t    uUnused     : 11;
-        /** The threaded call number (IEMTHREADEDFUNCS). */
-        uint32_t    enmCall     : 16;
-    } ThreadedCall;
-
-    struct
-    {
-        /* kIemTbDbgEntryType_Label. */
-        uint32_t    uType      : 4;
-        uint32_t    uUnused    : 4;
-        /** The label type (IEMNATIVELABELTYPE).   */
-        uint32_t    enmLabel   : 8;
-        /** The label data. */
-        uint32_t    uData      : 16;
-    } Label;
-
-    struct
-    {
-        /* kIemTbDbgEntryType_GuestRegShadowing. */
-        uint32_t    uType         : 4;
-        uint32_t    uUnused       : 4;
-        /** The guest register being shadowed (IEMNATIVEGSTREG). */
-        uint32_t    idxGstReg     : 8;
-        /** The host new register number, UINT8_MAX if dropped. */
-        uint32_t    idxHstReg     : 8;
-        /** The previous host register number, UINT8_MAX if new.   */
-        uint32_t    idxHstRegPrev : 8;
-    } GuestRegShadowing;
-
-#ifdef IEMNATIVE_WITH_SIMD_REG_ALLOCATOR
-    struct
-    {
-        /* kIemTbDbgEntryType_GuestSimdRegShadowing. */
-        uint32_t    uType             : 4;
-        uint32_t    uUnused           : 4;
-        /** The guest register being shadowed (IEMNATIVEGSTSIMDREG). */
-        uint32_t    idxGstSimdReg     : 8;
-        /** The host new register number, UINT8_MAX if dropped. */
-        uint32_t    idxHstSimdReg     : 8;
-        /** The previous host register number, UINT8_MAX if new.   */
-        uint32_t    idxHstSimdRegPrev : 8;
-    } GuestSimdRegShadowing;
-#endif
-
-#ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING
-    struct
-    {
-        /* kIemTbDbgEntryType_DelayedPcUpdate. */
-        uint32_t    uType         : 4;
-        /** Number of instructions skipped. */
-        uint32_t    cInstrSkipped : 8;
-        /* The instruction offset added to the program counter. */
-        int32_t     offPc         : 20;
-    } DelayedPcUpdate;
-#endif
-
-#if defined(IEMNATIVE_WITH_DELAYED_REGISTER_WRITEBACK) || defined(IEMNATIVE_WITH_SIMD_REG_ALLOCATOR)
-    struct
-    {
-        /* kIemTbDbgEntryType_GuestRegDirty. */
-        uint32_t    uType         : 4;
-        uint32_t    uUnused       : 11;
-        /** Flag whether this is about a SIMD (true) or general (false) register. */
-        uint32_t    fSimdReg      : 1;
-        /** The guest register index being marked as dirty. */
-        uint32_t    idxGstReg     : 8;
-        /** The host register number this register is shadowed in .*/
-        uint32_t    idxHstReg     : 8;
-    } GuestRegDirty;
-
-    struct
-    {
-        /* kIemTbDbgEntryType_GuestRegWriteback. */
-        uint32_t    uType         : 4;
-        /** Flag whether this is about a SIMD (true) or general (false) register flush. */
-        uint32_t    fSimdReg      : 1;
-        /** The mask shift. */
-        uint32_t    cShift        : 2;
-        /** The guest register mask being written back. */
-        uint32_t    fGstReg       : 25;
-    } GuestRegWriteback;
-#endif
-
-} IEMTBDBGENTRY;
-AssertCompileSize(IEMTBDBGENTRY, sizeof(uint32_t));
-/** Pointer to a debug info entry. */
-typedef IEMTBDBGENTRY *PIEMTBDBGENTRY;
-/** Pointer to a const debug info entry. */
-typedef IEMTBDBGENTRY const *PCIEMTBDBGENTRY;
-
-/**
- * Translation block debug info.
- */
-typedef struct IEMTBDBG
-{
-    /** This is the flat PC corresponding to IEMTB::GCPhysPc. */
-    RTGCPTR         FlatPc;
-    /** Number of entries in aEntries. */
-    uint32_t        cEntries;
-    /** The offset of the last kIemTbDbgEntryType_NativeOffset record. */
-    uint32_t        offNativeLast;
-    /** Debug info entries. */
-    RT_FLEXIBLE_ARRAY_EXTENSION
-    IEMTBDBGENTRY   aEntries[RT_FLEXIBLE_ARRAY];
-} IEMTBDBG;
-/** Pointer to TB debug info. */
-typedef IEMTBDBG *PIEMTBDBG;
-/** Pointer to const TB debug info. */
-typedef IEMTBDBG const *PCIEMTBDBG;
-
-
-/**
  * Translation block.
  *
@@ -1596,8 +1411,8 @@
         /** Native recompilation debug info if enabled.
          * This is only generated by the native recompiler. */
-        PIEMTBDBG       pDbgInfo;
+        struct IEMTBDBG    *pDbgInfo;
         /** For threaded TBs and natives when debug info is disabled, this is the flat
          * PC corresponding to GCPhysPc. */
-        RTGCPTR         FlatPc;
+        RTGCPTR             FlatPc;
     };
 
@@ -2385,4 +2200,7 @@
     STAMCOUNTER             StatNativeEflTotalShift;
 
+    /** Native recompiler: Number of emits per postponement. */
+    STAMPROFILE             StatNativeEflPostponedEmits;
+
     /** Native recompiler: Number of opportunities to skip EFLAGS.CF updating. */
     STAMCOUNTER             StatNativeLivenessEflCfSkippable;
@@ -2556,7 +2374,7 @@
 
 #ifdef IEM_WITH_TLB_TRACE
-    uint64_t                au64Padding[5];
+    uint64_t                au64Padding[1];
 #else
-    uint64_t                au64Padding[7];
+    uint64_t                au64Padding[3];
 #endif
 
Index: /trunk/src/VBox/VMM/include/IEMN8veRecompiler.h
===================================================================
--- /trunk/src/VBox/VMM/include/IEMN8veRecompiler.h	(revision 106191)
+++ /trunk/src/VBox/VMM/include/IEMN8veRecompiler.h	(revision 106192)
@@ -1232,4 +1232,207 @@
 
 /**
+ * Translation block debug info entry type.
+ */
+typedef enum IEMTBDBGENTRYTYPE
+{
+    kIemTbDbgEntryType_Invalid = 0,
+    /** The entry is for marking a native code position.
+     * Entries following this all apply to this position. */
+    kIemTbDbgEntryType_NativeOffset,
+    /** The entry is for a new guest instruction. */
+    kIemTbDbgEntryType_GuestInstruction,
+    /** Marks the start of a threaded call. */
+    kIemTbDbgEntryType_ThreadedCall,
+    /** Marks the location of a label. */
+    kIemTbDbgEntryType_Label,
+    /** Info about a host register shadowing a guest register. */
+    kIemTbDbgEntryType_GuestRegShadowing,
+#ifdef IEMNATIVE_WITH_SIMD_REG_ALLOCATOR
+    /** Info about a host SIMD register shadowing a guest SIMD register. */
+    kIemTbDbgEntryType_GuestSimdRegShadowing,
+#endif
+#ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING
+    /** Info about a delayed RIP update. */
+    kIemTbDbgEntryType_DelayedPcUpdate,
+#endif
+#if defined(IEMNATIVE_WITH_DELAYED_REGISTER_WRITEBACK) || defined(IEMNATIVE_WITH_SIMD_REG_ALLOCATOR)
+    /** Info about a shadowed guest register becoming dirty. */
+    kIemTbDbgEntryType_GuestRegDirty,
+    /** Info about register writeback/flush oepration. */
+    kIemTbDbgEntryType_GuestRegWriteback,
+#endif
+#ifdef IEMNATIVE_WITH_EFLAGS_POSTPONING
+    /** Info about a delayed EFLAGS calculation. */
+    kIemTbDbgEntryType_PostponedEFlagsCalc,
+#endif
+    kIemTbDbgEntryType_End
+} IEMTBDBGENTRYTYPE;
+
+/**
+ * Translation block debug info entry.
+ */
+typedef union IEMTBDBGENTRY
+{
+    /** Plain 32-bit view. */
+    uint32_t u;
+
+    /** Generic view for getting at the type field. */
+    struct
+    {
+        /** IEMTBDBGENTRYTYPE */
+        uint32_t    uType : 4;
+        uint32_t    uTypeSpecific : 28;
+    } Gen;
+
+    struct
+    {
+        /** kIemTbDbgEntryType_ThreadedCall1. */
+        uint32_t    uType      : 4;
+        /** Native code offset. */
+        uint32_t    offNative  : 28;
+    } NativeOffset;
+
+    struct
+    {
+        /** kIemTbDbgEntryType_GuestInstruction. */
+        uint32_t    uType      : 4;
+        uint32_t    uUnused    : 4;
+        /** The IEM_F_XXX flags. */
+        uint32_t    fExec      : 24;
+    } GuestInstruction;
+
+    struct
+    {
+        /* kIemTbDbgEntryType_ThreadedCall. */
+        uint32_t    uType       : 4;
+        /** Set if the call was recompiled to native code, clear if just calling
+         *  threaded function. */
+        uint32_t    fRecompiled : 1;
+        uint32_t    uUnused     : 11;
+        /** The threaded call number (IEMTHREADEDFUNCS). */
+        uint32_t    enmCall     : 16;
+    } ThreadedCall;
+
+    struct
+    {
+        /* kIemTbDbgEntryType_Label. */
+        uint32_t    uType      : 4;
+        uint32_t    uUnused    : 4;
+        /** The label type (IEMNATIVELABELTYPE).   */
+        uint32_t    enmLabel   : 8;
+        /** The label data. */
+        uint32_t    uData      : 16;
+    } Label;
+
+    struct
+    {
+        /* kIemTbDbgEntryType_GuestRegShadowing. */
+        uint32_t    uType         : 4;
+        uint32_t    uUnused       : 4;
+        /** The guest register being shadowed (IEMNATIVEGSTREG). */
+        uint32_t    idxGstReg     : 8;
+        /** The host new register number, UINT8_MAX if dropped. */
+        uint32_t    idxHstReg     : 8;
+        /** The previous host register number, UINT8_MAX if new.   */
+        uint32_t    idxHstRegPrev : 8;
+    } GuestRegShadowing;
+
+#ifdef IEMNATIVE_WITH_SIMD_REG_ALLOCATOR
+    struct
+    {
+        /* kIemTbDbgEntryType_GuestSimdRegShadowing. */
+        uint32_t    uType             : 4;
+        uint32_t    uUnused           : 4;
+        /** The guest register being shadowed (IEMNATIVEGSTSIMDREG). */
+        uint32_t    idxGstSimdReg     : 8;
+        /** The host new register number, UINT8_MAX if dropped. */
+        uint32_t    idxHstSimdReg     : 8;
+        /** The previous host register number, UINT8_MAX if new.   */
+        uint32_t    idxHstSimdRegPrev : 8;
+    } GuestSimdRegShadowing;
+#endif
+
+#ifdef IEMNATIVE_WITH_DELAYED_PC_UPDATING
+    struct
+    {
+        /* kIemTbDbgEntryType_DelayedPcUpdate. */
+        uint32_t    uType         : 4;
+        /** Number of instructions skipped. */
+        uint32_t    cInstrSkipped : 8;
+        /* The instruction offset added to the program counter. */
+        int32_t     offPc         : 20;
+    } DelayedPcUpdate;
+#endif
+
+#if defined(IEMNATIVE_WITH_DELAYED_REGISTER_WRITEBACK) || defined(IEMNATIVE_WITH_SIMD_REG_ALLOCATOR)
+    struct
+    {
+        /* kIemTbDbgEntryType_GuestRegDirty. */
+        uint32_t    uType         : 4;
+        uint32_t    uUnused       : 11;
+        /** Flag whether this is about a SIMD (true) or general (false) register. */
+        uint32_t    fSimdReg      : 1;
+        /** The guest register index being marked as dirty. */
+        uint32_t    idxGstReg     : 8;
+        /** The host register number this register is shadowed in .*/
+        uint32_t    idxHstReg     : 8;
+    } GuestRegDirty;
+
+    struct
+    {
+        /* kIemTbDbgEntryType_GuestRegWriteback. */
+        uint32_t    uType         : 4;
+        /** Flag whether this is about a SIMD (true) or general (false) register flush. */
+        uint32_t    fSimdReg      : 1;
+        /** The mask shift. */
+        uint32_t    cShift        : 2;
+        /** The guest register mask being written back. */
+        uint32_t    fGstReg       : 25;
+    } GuestRegWriteback;
+#endif
+
+#ifdef IEMNATIVE_WITH_EFLAGS_POSTPONING
+    struct
+    {
+        /* kIemTbDbgEntryType_PostponedEFlagsCalc. */
+        uint32_t    uType         : 4;
+        /** The EFLAGS operation (IEMNATIVE_POSTPONED_EFL_OP_T). */
+        uint32_t    enmOp         : 4;
+        /** The mask shift. */
+        uint32_t    cOpBits       : 8;
+        /** The emit instance number (0-based). */
+        uint32_t    idxEmit       : 8;
+        /** Unused. */
+        uint32_t    uUnused       : 8;
+    } PostponedEflCalc;
+#endif
+} IEMTBDBGENTRY;
+AssertCompileSize(IEMTBDBGENTRY, sizeof(uint32_t));
+/** Pointer to a debug info entry. */
+typedef IEMTBDBGENTRY *PIEMTBDBGENTRY;
+/** Pointer to a const debug info entry. */
+typedef IEMTBDBGENTRY const *PCIEMTBDBGENTRY;
+
+/**
+ * Translation block debug info.
+ */
+typedef struct IEMTBDBG
+{
+    /** This is the flat PC corresponding to IEMTB::GCPhysPc. */
+    RTGCPTR         FlatPc;
+    /** Number of entries in aEntries. */
+    uint32_t        cEntries;
+    /** The offset of the last kIemTbDbgEntryType_NativeOffset record. */
+    uint32_t        offNativeLast;
+    /** Debug info entries. */
+    RT_FLEXIBLE_ARRAY_EXTENSION
+    IEMTBDBGENTRY   aEntries[RT_FLEXIBLE_ARRAY];
+} IEMTBDBG;
+/** Pointer to TB debug info. */
+typedef IEMTBDBG *PIEMTBDBG;
+/** Pointer to const TB debug info. */
+typedef IEMTBDBG const *PCIEMTBDBG;
+
+/**
  * Guest registers that can be shadowed in GPRs.
  *
@@ -1847,4 +2050,8 @@
          *  UINT8_MAX if not in use. */
         uint8_t                         idxReg2;
+# if defined(VBOX_WITH_STATISTICS) || defined(IEMNATIVE_WITH_TB_DEBUG_INFO)
+        /** Number of times the delayed calculation was emitted. */
+        uint8_t                         cEmits;
+# endif
     } PostponedEfl;
 #endif
@@ -2000,4 +2207,9 @@
 DECL_HIDDEN_THROW(void)     iemNativeDbgInfoAddDelayedPcUpdate(PIEMRECOMPILERSTATE pReNative,
                                                                uint64_t offPc, uint32_t cInstrSkipped);
+# ifdef IEMNATIVE_WITH_EFLAGS_POSTPONING
+DECL_HIDDEN_THROW(void)     iemNativeDbgInfoAddPostponedEFlagsCalc(PIEMRECOMPILERSTATE pReNative, uint32_t off,
+                                                                   IEMNATIVE_POSTPONED_EFL_OP_T enmOp, uint8_t cOpBits,
+                                                                   uint8_t idxInstance);
+# endif
 #endif /* IEMNATIVE_WITH_TB_DEBUG_INFO */
 