Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 106217)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 106218)
@@ -2073,8 +2073,8 @@
     </method>
     <method name="start">
-      <rest request="post" path="/natnetworks/{networkid}/actions/"/>
+      <rest request="post" path="/natnetworks/{networkid}/action/"/>
     </method>
     <method name="stop">
-      <rest request="post" path="/natnetworks/{networkid}/actions/"/>
+      <rest request="post" path="/natnetworks/{networkid}/action/"/>
     </method>
   </interface>
@@ -2401,5 +2401,5 @@
 
     <method name="start">
-      <rest request="post" path="/dhcpservers/{serverid}/actions/"/>
+      <rest request="post" path="/dhcpservers/{serverid}/action/"/>
       <desc>
         Starts DHCP server process.
@@ -2421,5 +2421,5 @@
 
     <method name="stop">
-      <rest request="post" path="/dhcpservers/{serverid}/actions/"/>
+      <rest request="post" path="/dhcpservers/{serverid}/action/"/>
       <desc>
         Stops DHCP server process.
@@ -2431,5 +2431,5 @@
 
     <method name="restart">
-      <rest request="post" path="/dhcpservers/{serverid}/actions/"/>
+      <rest request="post" path="/dhcpservers/{serverid}/action/"/>
       <desc>
         Restart running DHCP server process.
@@ -2986,5 +2986,5 @@
 
     <method name="composeMachineFilename">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Returns a recommended full path of the settings file name for a new virtual
@@ -3186,5 +3186,5 @@
 
     <method name="openMachine">
-      <rest name="open" request="post" path="/vms/{vmid}/actions/"/>
+      <rest name="open" request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Opens a virtual machine from the existing settings file.
@@ -3232,5 +3232,5 @@
 
     <method name="registerMachine">
-      <rest name="register" request="post" path="/vms/{vmid}/actions/"/>
+      <rest name="register" request="post" path="/vms/{vmid}/action/"/>
       <desc>
 
@@ -3279,5 +3279,5 @@
 
     <method name="getMachinesByGroups">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Gets all machine references which are in one of the specified groups.
@@ -3294,5 +3294,5 @@
 
     <method name="getMachineStates">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Gets the state of several machines in a single operation.
@@ -3319,5 +3319,5 @@
 
     <method name="createUnattendedInstaller">
-      <rest request="post" path="/server/methods/"/>
+      <rest request="post" path="/server/method/"/>
       <desc>
         Creates a new <link to="IUnattended"/> guest installation object.  This can be used to
@@ -3410,5 +3410,5 @@
 
     <method name="openMedium">
-      <rest request="post" path="/server/methods/"/>
+      <rest request="post" path="/server/method/"/>
       <desc>
         Finds existing media or opens a medium from an existing storage location.
@@ -3507,5 +3507,5 @@
 
     <method name="getGuestOSType">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Returns an object describing the specified guest OS type.
@@ -3540,5 +3540,5 @@
 
     <method name="getGuestOSSubtypesByFamilyId">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Returns a list of guest OS family subtypes for a corresponding
@@ -3566,5 +3566,5 @@
 
     <method name="getGuestOSDescsBySubtype">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Returns a list of guest OS family descriptions for a corresponding
@@ -3641,5 +3641,5 @@
 
     <method name="getExtraDataKeys">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Returns an array representing the global extra data keys which currently
@@ -3652,5 +3652,5 @@
 
     <method name="getExtraData">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Returns associated global extra data.
@@ -3676,5 +3676,5 @@
 
     <method name="setExtraData">
-      <rest request="put" path="/server/methods/"/>
+      <rest request="put" path="/server/method/"/>
       <desc>
         Sets associated global extra data.
@@ -3914,5 +3914,5 @@
 
     <method name="checkFirmwarePresent">
-      <rest request="get" path="/server/methods/"/>
+      <rest request="get" path="/server/method/"/>
       <desc>
         Check if this VirtualBox installation has a firmware
@@ -4418,5 +4418,5 @@
 
     <method name="read">
-      <rest request="post" path="/appliances/{applianceid}/actions/"/>
+      <rest request="post" path="/appliances/{applianceid}/action/"/>
       <desc>
         Reads an OVF file into the appliance object.
@@ -4438,5 +4438,5 @@
 
     <method name="interpret">
-      <rest request="post" path="/appliances/{applianceid}/actions/"/>
+      <rest request="post" path="/appliances/{applianceid}/action/"/>
       <desc>
         Interprets the OVF data that was read when the appliance was constructed. After
@@ -4456,5 +4456,5 @@
 
     <method name="importMachines">
-      <rest request="post" path="/appliances/{applianceid}/actions/"/>
+      <rest request="post" path="/appliances/{applianceid}/action/"/>
       <desc>
         Imports the appliance into VirtualBox by creating instances of <link to="IMachine" />
@@ -4496,5 +4496,5 @@
 
     <method name="write">
-      <rest request="post" path="/appliances/{applianceid}/actions/"/>
+      <rest request="post" path="/appliances/{applianceid}/action/"/>
       <desc>
           Writes the contents of the appliance exports into a new OVF file.
@@ -8214,5 +8214,5 @@
 
     <method name="lockMachine">
-      <rest name="lock" request="post" path="/vms/{vmid}/actions/"/>
+      <rest name="lock" request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Locks the machine for the given session to enable the caller
@@ -8314,5 +8314,5 @@
 
     <method name="launchVMProcess">
-      <rest name="launch" request="post" path="/vms/{vmid}/actions/"/>
+      <rest name="launch" request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Spawns a new process that will execute the virtual machine and obtains a shared
@@ -8979,5 +8979,5 @@
 
     <method name="unmountMedium">
-      <rest name="unmount" request="post" path="/vms/{vmid}/media/actions/"/>
+      <rest name="unmount" request="post" path="/vms/{vmid}/media/action/"/>
       <desc>
         Unmounts any currently mounted medium (<link to="IMedium" />,
@@ -9032,5 +9032,5 @@
 
     <method name="mountMedium">
-      <rest name="mount" request="post" path="/vms/{vmid}/media/actions/"/>
+      <rest name="mount" request="post" path="/vms/{vmid}/media/action/"/>
       <desc>
         Mounts a medium (<link to="IMedium" />, identified
@@ -9574,5 +9574,5 @@
 
     <method name="unregister" wrap-hint-server="limitedcaller,passcaller">
-      <rest request="post" path="/vms/{vmid}/actions/"/>
+      <rest request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Unregisters a machine previously registered with
@@ -9709,5 +9709,5 @@
 
     <method name="exportTo">
-      <rest name="export" request="post" path="/vms/{vmid}/actions/"/>
+      <rest name="export" request="post" path="/vms/{vmid}/action/"/>
       <desc>Exports the machine to an OVF appliance. See <link to="IAppliance" /> for the
             steps required to export VirtualBox machines to OVF.
@@ -9750,5 +9750,5 @@
 
     <method name="createSharedFolder">
-      <rest request="post" path="/vms/{vmid}/methods/"/>
+      <rest request="post" path="/vms/{vmid}/method/"/>
       <desc>
         Creates a new permanent shared folder by associating the given logical
@@ -9787,5 +9787,5 @@
 
     <method name="removeSharedFolder">
-      <rest request="delete" path="/vms/{vmid}/methods/"/>
+      <rest request="delete" path="/vms/{vmid}/method/"/>
       <desc>
         Removes the permanent shared folder with the given name previously
@@ -10293,5 +10293,5 @@
 
     <method name="cloneTo">
-      <rest name="clone" request="post" path="/vms/{vmid}/actions/"/>
+      <rest name="clone" request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Creates a clone of this machine, either as a full clone (which means
@@ -10329,5 +10329,5 @@
 
     <method name="moveTo">
-      <rest name="move" request="post" path="/vms/{vmid}/actions/"/>
+      <rest name="move" request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Move machine on to new place/folder
@@ -10356,5 +10356,5 @@
 
     <method name="saveState">
-      <rest name="save" request="post" path="/vms/{vmid}/actions/"/>
+      <rest name="save" request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Saves the current execution state of a running virtual machine
@@ -10430,5 +10430,5 @@
 
     <method name="discardSavedState">
-      <rest request="post" path="/vms/{vmid}/actions/"/>
+      <rest request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Forcibly resets the machine to "Powered Off" state if it is
@@ -10458,5 +10458,5 @@
 
     <method name="takeSnapshot">
-      <rest request="put" path="/vms/{vmid}/actions/"/>
+      <rest request="put" path="/vms/{vmid}/action/"/>
       <desc>
         Saves the current execution state
@@ -10506,5 +10506,5 @@
 
     <method name="deleteSnapshot">
-      <rest request="delete" path="/vms/{vmid}/actions/"/>
+      <rest request="delete" path="/vms/{vmid}/action/"/>
       <desc>
         Starts deleting the specified snapshot asynchronously.
@@ -10578,5 +10578,5 @@
 
     <method name="deleteSnapshotAndAllChildren">
-      <rest request="post" path="/vms/{vmid}/actions/"/>
+      <rest request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Starts deleting the specified snapshot and all its children
@@ -10612,5 +10612,5 @@
 
     <method name="deleteSnapshotRange">
-      <rest request="post" path="/vms/{vmid}/actions/"/>
+      <rest request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Starts deleting the specified snapshot range. This is limited to
@@ -10651,5 +10651,5 @@
 
     <method name="restoreSnapshot">
-      <rest request="post" path="/vms/{vmid}/actions/"/>
+      <rest request="post" path="/vms/{vmid}/action/"/>
       <desc>
         Starts resetting the machine's current state to the state contained
@@ -11184,5 +11184,5 @@
 
     <method name="powerUp">
-      <rest request="post" path="/vms/{vmid}/console/actions/"/>
+      <rest request="post" path="/vms/{vmid}/console/action/"/>
       <desc>
         Starts the virtual machine execution using the current machine
@@ -11237,5 +11237,5 @@
 
     <method name="powerUpPaused">
-      <rest request="post" path="/vms/{vmid}/console/actions/"/>
+      <rest request="post" path="/vms/{vmid}/console/action/"/>
       <desc>
         Identical to powerUp except that the VM will enter the
@@ -11260,5 +11260,5 @@
 
     <method name="powerDown">
-      <rest request="post" path="/vms/{vmid}/console/actions/"/>
+      <rest request="post" path="/vms/{vmid}/console/action/"/>
       <desc>
         Initiates the power down procedure to stop the virtual machine
@@ -11278,5 +11278,5 @@
 
     <method name="reset">
-      <rest request="post" path="/vms/{vmid}/console/actions/"/>
+      <rest request="post" path="/vms/{vmid}/console/action/"/>
       <desc>Resets the virtual machine.
         <result name="VBOX_E_INVALID_VM_STATE">
@@ -11290,5 +11290,5 @@
 
     <method name="pause">
-      <rest request="post" path="/vms/{vmid}/console/actions/"/>
+      <rest request="post" path="/vms/{vmid}/console/action/"/>
       <desc>Pauses the virtual machine execution.
         <result name="VBOX_E_INVALID_VM_STATE">
@@ -11302,5 +11302,5 @@
 
     <method name="resume">
-      <rest request="post" path="/vms/{vmid}/console/actions/"/>
+      <rest request="post" path="/vms/{vmid}/console/action/"/>
       <desc>Resumes the virtual machine execution.
         <result name="VBOX_E_INVALID_VM_STATE">
@@ -11314,5 +11314,5 @@
 
     <method name="powerButton">
-      <rest request="post" path="/vms/{vmid}/console/actions/"/>
+      <rest request="post" path="/vms/{vmid}/console/action/"/>
       <desc>Sends the ACPI power button event to the guest.
         <result name="VBOX_E_INVALID_VM_STATE">
@@ -11326,5 +11326,5 @@
 
     <method name="sleepButton">
-      <rest request="post" path="/vms/{vmid}/console/actions/"/>
+      <rest request="post" path="/vms/{vmid}/console/action/"/>
       <desc>Sends the ACPI sleep button event to the guest.
         <result name="VBOX_E_INVALID_VM_STATE">
@@ -11472,5 +11472,5 @@
 
     <method name="createSharedFolder">
-      <rest request="post" path="/vms/{vmid}/console/methods/"/>
+      <rest request="post" path="/vms/{vmid}/console/method/"/>
       <desc>
         Creates a transient new shared folder by associating the given logical
@@ -11508,5 +11508,5 @@
 
     <method name="removeSharedFolder">
-      <rest request="post" path="/vms/{vmid}/console/methods/"/>
+      <rest request="post" path="/vms/{vmid}/console/method/"/>
       <desc>
         Removes a transient shared folder with the given name previously
@@ -11565,5 +11565,5 @@
 
     <method name="addEncryptionPassword">
-      <rest request="post" path="/vms/{vmid}/console/methods/"/>
+      <rest request="post" path="/vms/{vmid}/console/method/"/>
       <desc>
         Adds a password used for encryption/decryption.
@@ -11592,5 +11592,5 @@
 
     <method name="addEncryptionPasswords">
-      <rest request="post" path="/vms/{vmid}/console/methods/"/>
+      <rest request="post" path="/vms/{vmid}/console/method/"/>
       <desc>
         Adds a password used for encryption/decryption.
@@ -11619,5 +11619,5 @@
 
     <method name="removeEncryptionPassword">
-      <rest request="post" path="/vms/{vmid}/console/methods/"/>
+      <rest request="post" path="/vms/{vmid}/console/method/"/>
       <desc>
         Removes a password used for hard disk encryption/decryption from
@@ -11635,5 +11635,5 @@
 
     <method name="clearAllEncryptionPasswords">
-      <rest request="post" path="/vms/{vmid}/console/methods/"/>
+      <rest request="post" path="/vms/{vmid}/console/method/"/>
       <desc>Clears all provided supplied encryption passwords.</desc>
     </method>
@@ -18189,5 +18189,5 @@
 
     <method name="waitForCompletion">
-      <rest request="post" path="/progresses/{progressid}/actions/"/>
+      <rest request="post" path="/progresses/{progressid}/action/"/>
       <desc>
           Waits until the task is done (including all sub-operations)
@@ -18215,5 +18215,5 @@
 
     <method name="waitForOperationCompletion">
-      <rest request="post" path="/progresses/{progressid}/actions/"/>
+      <rest request="post" path="/progresses/{progressid}/action/"/>
       <desc>
           Waits until the given operation is done with a given timeout in
@@ -18241,5 +18241,5 @@
 
     <method name="cancel">
-      <rest request="post" path="/progresses/{progressid}/actions/"/>
+      <rest request="post" path="/progresses/{progressid}/action/"/>
       <desc>
         Cancels the task.
@@ -19597,5 +19597,5 @@
 
     <method name="close" wrap-hint-server="passcaller">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Closes this medium.
@@ -19758,5 +19758,5 @@
 
     <method name="createBaseStorage">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts creating a hard disk storage unit (fixed/dynamic, according
@@ -19793,5 +19793,5 @@
 
     <method name="deleteStorage">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts deleting the storage unit of this medium.
@@ -19840,5 +19840,5 @@
 
     <method name="createDiffStorage" wrap-hint-server="passcaller">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts creating an empty differencing storage unit based on this
@@ -19878,5 +19878,5 @@
 
     <method name="mergeTo">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts merging the contents of this medium and all intermediate
@@ -19961,5 +19961,5 @@
 
     <method name="cloneTo">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts creating a clone of this medium in the format and at the
@@ -20011,5 +20011,5 @@
 
     <method name="cloneToBase">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
     <desc>
     Starts creating a clone of this medium in the format and at the
@@ -20059,5 +20059,5 @@
 
     <method name="moveTo" wrap-hint-server="passcaller">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Changes the location of this medium. Some medium types may support
@@ -20096,5 +20096,5 @@
 
     <method name="compact">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts compacting of this medium. This means that the medium is
@@ -20123,5 +20123,5 @@
 
     <method name="resize">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts resizing this medium. This means that the nominal size of the
@@ -20155,5 +20155,5 @@
 
     <method name="reset" wrap-hint-server="passcaller">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts erasing the contents of this differencing medium.
@@ -20182,5 +20182,5 @@
 
     <method name="changeEncryption">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
       <desc>
         Starts encryption of this medium. This means that the stored data in the
@@ -20276,5 +20276,5 @@
 
     <method name="resizeAndCloneTo">
-      <rest request="post" path="/media/{mediumid}/actions/"/>
+      <rest request="post" path="/media/{mediumid}/action/"/>
 
       <desc>