Index: trunk/doc/manual/en_US/dita/topics/guestossupport.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/guestossupport.dita	(revision 106204)
+++ 	(revision )
@@ -1,345 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="guestossupport">
-  <title>Supported Guest Operating Systems</title>
-  
-  <body>
-    <p>Because <ph conkeyref="vbox-conkeyref-phrases/product-name"/> is designed to provide a generic virtualization
-      environment for x86 systems, it can run guest operating systems (OSes) of any kind. </p>
-    <!-- 7.1: Require info on supported aarch64 guest OSes -->
-    <p>The following guest OS platforms are supported: </p>
-    <ul>
-      <li>
-        <p><b outputclass="bold">Platforms With Full Support.</b>
-          These guest OS platforms qualify for Oracle Premier Support.
-          See <xref href="#guestossupport/table-premier-support"/>.
-        </p>
-      </li>
-      <li>
-        <p><b outputclass="bold">Platforms With Limited Support.</b> These legacy guest OS platforms
-          can be used with <ph conkeyref="vbox-conkeyref-phrases/product-name"/>, but only qualify
-          for limited support because of the vintage of the technology involved. Therefore,
-          resolution of customer issues for such legacy guest OS platforms cannot be assured. See
-            <xref href="#guestossupport/table-limited-support"/>. </p>
-      </li>
-    </ul>
-    <table id="table-premier-support">
-      <title>Guest Operating Systems With Full Support</title>
-      <desc>Guest Operating Systems With Full Support</desc>
-      <tgroup cols="2">
-        <thead>
-          <row>
-            <entry>
-              <p>
-                <b outputclass="bold">Operating System</b>
-              </p>
-            </entry>
-            <entry>
-              <p>
-                <b outputclass="bold">Comments</b>
-              </p>
-            </entry>
-          </row>
-        </thead>
-        <tbody>
-          <row>
-            <entry>
-              <p>
-                Windows 11 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p>
-                Insider preview builds are not supported
-              </p>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows 10 (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p>
-                Insider preview builds are not supported
-              </p>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows 8 and 8.1 (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows Server 2019 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows Server 2016 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows Server 2012 and 2012 R2 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Solaris 11 (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Solaris 10 8/11 Update 10 and later (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Oracle Linux 9 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p>
-                Includes Red Hat Enterprise Linux 9, CentOS 9
-              </p>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Oracle Linux 8 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p>
-                Includes Red Hat Enterprise Linux 8, CentOS 8
-              </p>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Oracle Linux 7 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p>
-                Includes Red Hat Enterprise Linux 7, CentOS 7
-              </p>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Oracle Linux 6 (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p>
-                Includes Red Hat Enterprise Linux 6, CentOS 6
-              </p>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Ubuntu 16.04 LTS (Xenial Xerus) (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Ubuntu 18.04 LTS (Bionic Beaver) (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Ubuntu 20.04 LTS (Focal Fossa) (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                SUSE Linux Enterprise Server 15 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                SUSE Linux Enterprise Server 12 (64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-        </tbody>
-      </tgroup>
-    </table>
-    <table id="table-limited-support">
-      <title>Legacy Guest Operating Systems With Limited Support</title>
-      <desc>Legacy Guest Operating Systems With Limited Support</desc>
-      <tgroup cols="2">
-        <thead>
-          <row>
-            <entry>
-              <p>
-                <b outputclass="bold">Operating System</b>
-              </p>
-            </entry>
-            <entry>
-              <p>
-                <b outputclass="bold">Comments</b>
-              </p>
-            </entry>
-          </row>
-        </thead>
-        <tbody>
-          <row>
-            <entry>
-              <p>
-                Windows 7 (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows Vista SP2 and later (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows XP (32-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows Vista (32-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows Server 2008 and 2008 R2 (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Windows Server 2003 (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Oracle Linux 5 (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p>
-                Includes Red Hat Enterprise Linux 5, CentOS 5
-              </p>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                Ubuntu 14.04.5 LTS (Trusty Tahr) (32-bit and 64-bit)
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-          <row>
-            <entry>
-              <p>
-                OS/2 Warp 4.5
-              </p>
-            </entry>
-            <entry>
-              <p/>
-            </entry>
-          </row>
-        </tbody>
-      </tgroup>
-    </table>
-  </body>
-</topic>
Index: trunk/doc/manual/en_US/dita/topics/gui-details-preview.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/gui-details-preview.dita	(revision 106204)
+++ 	(revision )
@@ -1,12 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="gui-details-preview">
-  <title>Preview Window</title>
-  
-  <body>
-    <p>The virtual machine display is shown in a small window. </p>
-    <p>You can use the Preview window to check if your virtual machine has finished booting up. </p>
-    <p>Click the arrow icon to hide or show the Preview window. </p>
-  </body>
-  
-</topic>
Index: trunk/doc/manual/en_US/dita/topics/gui-details-settings.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/gui-details-settings.dita	(revision 106204)
+++ 	(revision )
@@ -1,24 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="gui-details-settings">
-  <title>Settings</title>
-  
-  <body>
-    <p>A summary of settings is shown for the virtual machine. </p>
-    <note>
-      <p>Settings shown may vary, depending on the selected experience level for the <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> user interface.</p>
-      <p>See <xref href="ui-experience-level.dita#gui-experience-level"/>.</p>
-    </note>
-    <p>You can change some virtual machine settings, by clicking on the setting in the Details pane. </p>
-    <note>
-      <p>If a virtual machine is running, some settings cannot be altered. You must stop the virtual machine first in
-        order to change the setting. </p>
-    </note>
-    <p>Virtual machine settings can also be changed using the <b outputclass="bold">Settings</b> button on the <ph
-        conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> toolbar. </p>
-    <p>The virtual machine settings on the Details pane are organized in sections that correspond to those used in the
-        <b outputclass="bold">Settings</b> window. See <xref href="BasicConcepts.dita#BasicConcepts"/>. </p>
-    <p>Click the arrow icon to hide or show each section. </p>
-  </body>
-  
-</topic>
Index: trunk/doc/manual/en_US/dita/topics/gui-details-toolbar.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/gui-details-toolbar.dita	(revision 106204)
+++ 	(revision )
@@ -1,45 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="gui-details-toolbar">
-  <title><ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> Toolbar</title>
-  
-  <body>
-    <p>A toolbar at the top of the Details pane contains buttons that enable you to configure the selected virtual
-      machine, or to create a new virtual machine. </p>
-    <p>The toolbar includes the following buttons: </p>
-    <ul>
-      <li>
-        <p><b outputclass="bold">New.</b> Creates a new
-              virtual machine, and adds it to the machine list.
-            </p>
-      </li>
-      <li>
-        <p><b outputclass="bold">Add.</b> Adds an existing
-              virtual machine to the machine list.
-            </p>
-      </li>
-      <li>
-        <p><b outputclass="bold">Settings.</b> Displays the
-              <b outputclass="bold">Settings</b> window for the
-              virtual machine, enabling you to make configuration
-              changes.
-            </p>
-      </li>
-      <li>
-        <p><b outputclass="bold">Discard.</b> For a running
-              virtual machine, discards the saved state for the virtual
-              machine and closes it down.
-            </p>
-      </li>
-      <li>
-        <p><b outputclass="bold">Show/Start.</b> For a running
-              virtual machine, <b outputclass="bold">Show</b>
-              displays the virtual machine window. For a stopped virtual
-              machine, <b outputclass="bold">Start</b> displays
-              options for powering up the virtual machine.
-            </p>
-      </li>
-    </ul>
-  </body>
-  
-</topic>
Index: trunk/doc/manual/en_US/dita/topics/gui-details.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/gui-details.dita	(revision 106204)
+++ 	(revision )
@@ -1,11 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="gui-details">
-  <title>The Details Pane</title>
-  
-  <body>
-    <p>The Details pane shows configuration information for a virtual machine that is selected in the machine list. The
-      pane also includes a toolbar for performing tasks. </p>
-    <p>The Details pane includes the following: </p>
-  </body>
-</topic>
Index: trunk/doc/manual/en_US/dita/topics/gui-notification-center.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/gui-notification-center.dita	(revision 106204)
+++ 	(revision )
@@ -1,11 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="gui-notification-center">
-  <title>Notification Center</title>
-  
-  <body>
-    <p>The <b outputclass="bold">Notification Center</b> shows tasks in progress and warns of errors and task failures. </p>
-    <p>Click <uicontrol>Open notification center</uicontrol> to see the list of notifications. </p>
-  </body>
-  
-</topic>
Index: trunk/doc/manual/en_US/dita/topics/gui-tools.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/gui-tools.dita	(revision 106204)
+++ 	(revision )
@@ -1,24 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="gui-tools">
-  <title><ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> Tools</title>
-  
-  <body>
-    <p><ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> provides two types of user tools, to enable you to perform
-      common tasks easily. </p>
-    <ul>
-      <li>
-        <p><b outputclass="bold">Global Tools.</b> These tools
-            apply to <i>all</i> virtual machines. See
-            <xref href="gui-tools-global.dita#gui-tools-global"/>.
-          </p>
-      </li>
-      <li>
-        <p><b outputclass="bold">Machine Tools.</b> These tools
-            apply to a <i>specific</i> virtual machine.
-            See <xref href="gui-tools-machine.dita#gui-tools-machine"/>.
-          </p>
-      </li>
-    </ul>
-  </body>
-</topic>
Index: trunk/doc/manual/en_US/dita/topics/help-viewer.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/help-viewer.dita	(revision 106204)
+++ 	(revision )
@@ -1,76 +1,0 @@
-<?xml version='1.0' encoding='UTF-8'?>
-<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="help-viewer">
-  <title>Help Viewer</title>
-  
-  <body>
-    <p>The Help Viewer is a window that displays context-sensitive help to assist you in completing common <ph
-        conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> tasks. You can display the Help Viewer in the following ways: </p>
-    <ul>
-      <li>
-        <p>In a <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> wizard or dialog, click <b outputclass="bold">Help</b>
-          to display the relevant help topic. </p>
-      </li>
-      <li>
-        <p>In <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> or from a guest VM, do either of the following: </p>
-        <ul>
-          <li>
-            <p>
-                Select the <b outputclass="bold">Help</b>,
-                <b outputclass="bold">Contents</b> menu option.
-              </p>
-          </li>
-          <li>
-            <p>
-                Press the <b outputclass="bold">F1</b> button.
-              </p>
-            <p>The keyboard shortcut used to access the Help Viewer can be configured in the <b outputclass="bold"
-                >Preferences</b> window. </p>
-          </li>
-        </ul>
-      </li>
-    </ul>
-    <p>The Help Viewer has the following features: </p>
-    <ul>
-      <li>
-        <p><b outputclass="bold">Navigation tools.</b> The left
-            hand pane contains the following navigation tools:
-          </p>
-        <ul>
-          <li>
-            <p><b outputclass="bold">Contents.</b> Displays the
-                help topic location in the <ph conkeyref="vbox-conkeyref-phrases/product-name"/> documentation.
-              </p>
-          </li>
-          <li>
-            <p><b outputclass="bold">Search.</b> Enables you to
-                search the documentation for help topics.
-              </p>
-          </li>
-          <li>
-            <p><b outputclass="bold">Bookmarks.</b> Enables you
-                to bookmark useful help topics.
-              </p>
-          </li>
-        </ul>
-      </li>
-      <li>
-        <p><b outputclass="bold">Tabbed browsing.</b> Help
-            topics that you have visited are displayed in tabs in the
-            main window pane.
-          </p>
-      </li>
-      <li>
-        <p><b outputclass="bold">Zoomable topics.</b> Zoom
-            controls enable you to enlarge help topic details.
-          </p>
-      </li>
-      <li>
-        <p><b outputclass="bold">Printing.</b> Help topics can
-            be printed to PDF file or to a local printer.
-          </p>
-      </li>
-    </ul>
-  </body>
-  
-</topic>
Index: trunk/doc/manual/en_US/dita/topics/vboxmanager-wizards.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vboxmanager-wizards.dita	(revision 106204)
+++ 	(revision )
@@ -1,47 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE topic
-  PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
-<topic xml:lang="en-us" id="vboxmanager-wizards">
-               <title>About <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> Wizards</title>
-               
-               <body>
-                  <p>
-        <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> includes wizards that enable you to complete tasks
-        easily. Examples of such tasks are when you create a new virtual
-        machine or use the cloud integration features of <ph conkeyref="vbox-conkeyref-phrases/product-name"/>.
-      </p>
-                  <p>
-        To display a help topic for the wizard, click the
-        <b outputclass="bold">Help</b> button.
-      </p>
-                  <p>
-        Some wizards can be displayed in either of the following modes:
-      </p>
-                  <ul>
-                     <li>
-                        <p>
-                           <b outputclass="bold">Guided mode.</b> This is the
-            default display mode. Wizards are shown in the conventional
-            manner, using a series of pages with descriptions to guide
-            the user through the steps for a task.
-          </p>
-                     </li>
-                     <li>
-                        <p>
-                           <b outputclass="bold">
-                              <b outputclass="bold">Expert
-            mode.</b>
-                           </b> This display mode is designed
-            for more advanced users of <ph conkeyref="vbox-conkeyref-phrases/product-name"/>. All settings are
-            displayed on a single page, enabling quicker completion of
-            tasks.
-          </p>
-                     </li>
-                  </ul>
-                  <p>
-        Click the button at the bottom of the wizard window to switch
-        between Guided mode and Expert mode.
-      </p>
-               </body>
-               
-            </topic>